#include "gtest/gtest.h"
#include "functions.h"

#include <vector>
#include <deque>

TEST(Modify, CreateDataStreamTest) {
  const std::string filename = "../test_files/test3.txt";
  CreateDataStream(filename);
  auto result1 = LoadDataStream<std::vector<int>>(filename);
  auto result2 = LoadDataCopy<std::vector<int>>(filename);
  ASSERT_EQ(result1 == result2, true);
}

TEST(Modify, CreateDataGenerateTest) {
  const std::string filename = "../test_files/test4.txt";
  CreateDataGenerate(filename);
  auto result1 = LoadDataStream<std::list<int>>(filename);
  auto result2 = LoadDataCopy<std::deque<int>>(filename);
  ASSERT_EQ(true, std::equal(result1.begin(), result1.end(), result2.begin()));
}