#include "db_person.h"

DBPerson::DBPerson(const std::string &filename) : filename(filename) {

}
void DBPerson::Open() {
  std::ofstream fout;
  fout.open(filename, std::ios::binary | std::ios::app);
  if (!fout.fail()) {
    fout.open(filename, std::ios::binary | std::ios::out);
  }

  std::cout << "Enter new persons" << std::endl;
  std::cout
      << "| " << std::setw(10) << "Person number"
      << " | " << std::setw(10) << "Department number"
      << " | " << std::setw(10) << "Name"
      << " | " << std::setw(10) << "Surname"
      << " | " << std::setw(6) << "Patronymic"
      << " | " << std::setw(6) << "Salary"
      << " | " << std::setw(2) << "dayStart"
      << " | " << std::setw(4) << "yearStart"
      << " | " << std::setw(2) << "premiumPercent"
      << " | " << std::setw(6) << "tax"
      << " | " << std::setw(2) << "workDaysCountDone"
      << " | " << std::setw(2) << "workDaysCount"
      << " | " << std::setw(6) << "received"
      << " | " << std::setw(6) << "withheld"
      << " | " << std::setw(6) << "gender"
      << " |" << std::endl;

  Person person{};

  while (true) {
    std::cin >> person;
    fout.write(reinterpret_cast<const char *>(&person), sizeof(person));
    std::cout << "0 - End input" << std::endl
              << "1 - Add more persons" << std::endl;
    int result;
    std::cin >> result;
    if (result == 0) {
      break;
    }
  }

  fout.close();
}
void DBPerson::LoadData() {
  std::ifstream dbInput(filename, std::ios::binary | std::ios::in);
  Person currentPerson;
  std::ifstream fileInput(filename);
  int id = 0;
  while (fileInput.read(reinterpret_cast<char *>(&currentPerson), sizeof(currentPerson))) {
    dataTable.insert(std::make_pair(++id, currentPerson));
  }
  dbInput.close();
}

void DBPerson::SelectByDepartmentNumber(const std::string &savefilename, int departmentNumber) {
  LoadData();
  std::ofstream outputFile(savefilename, std::ios::binary | std::ios::out);
  auto filterOperation = [departmentNumber, &outputFile]
      (const std::pair<int, Person> &current) {
    if (current.second.departmentNumber == departmentNumber) {
      outputFile.write(reinterpret_cast<const char *>(&current.second), sizeof(Person));
    }
  };

  std::for_each(dataTable.begin(),
                dataTable.end(),
                filterOperation);
  outputFile.close();
}
void DBPerson::SelectByGender(const std::string &savefilename, bool gender) {
  LoadData();
  std::ofstream outputFile(savefilename, std::ios::binary | std::ios::out);
  auto filterOperation = [gender, &outputFile]
      (const std::pair<int, Person> &current) {
    if (current.second.gender == gender) {
      outputFile.write(reinterpret_cast<const char *>(&current.second), sizeof(Person));
    }
  };

  std::for_each(dataTable.begin(),
                dataTable.end(),
                filterOperation);
  outputFile.close();
}
void DBPerson::SelectByDateStart(const std::string &savefilename, int dayStart, int monthStart, int yearStart) {
  LoadData();
  std::ofstream outputFile(savefilename, std::ios::binary | std::ios::out);
  auto filterOperation = [dayStart, monthStart, yearStart, &outputFile]
      (const std::pair<int, Person> &current) {
    if (current.second.dayStart == dayStart &&
        current.second.monthStart == monthStart &&
        current.second.yearStart == yearStart) {
      outputFile.write(reinterpret_cast<const char *>(&current.second), sizeof(Person));
    }
  };

  std::for_each(dataTable.begin(),
                dataTable.end(),
                filterOperation);
  outputFile.close();
}


